

// We make these interrupts faster by not using an array...
// even though the array is cleaner, it takes more time to handle
// all of the memory access.  :/

unsigned int heartbeatCount = 0;
char isrLEDCount = 0;

ISR(TIMER1_COMPA_vect){
  // Heartbeat debug light...
  if(heartbeatCount < 4000 && isrLEDCount == 0){
    setDebugLightOn();
  }
  if(heartbeatCount > 12000 && heartbeatCount < 18000 && isrLEDCount == 0){
    setDebugLightOn();
  }
  isrLEDCount++;
  if(isrLEDCount > 5){
    isrLEDCount = 0;
  }
  heartbeatCount++;
  if(heartbeatCount > 40000){
    heartbeatCount = 0;
  }
  // OUT 0
  if(outputCounter_0 < outputOnFor_0){
    setOut0_HIGH();
  }
  else{
    setOut0_LOW();
  }
  outputCounter_0++;
  if(outputCounter_0 >= outputPeriod_0){
    outputCounter_0 = 0;
  }
  // OUT 1
  if(outputCounter_1 < outputOnFor_1){
    setOut1_HIGH();
  }
  else{
    setOut1_LOW();
  }
  outputCounter_1++;
  if(outputCounter_1 >= outputPeriod_1){
    outputCounter_1 = 0;
  }
  // OUT 2
  if(outputCounter_2 < outputOnFor_2){
    setOut2_HIGH();
  }
  else{
    setOut2_LOW();
  }
  outputCounter_2++;
  if(outputCounter_2 >= outputPeriod_2){
    outputCounter_2 = 0;
  }
  // OUT 3
  if(outputCounter_3 < outputOnFor_3){
    setOut3_HIGH();
  }
  else{
    setOut3_LOW();
  }
  outputCounter_3++;
  if(outputCounter_3 >= outputPeriod_3){
    outputCounter_3 = 0;
  }
  // OUT 4
  if(outputCounter_4 < outputOnFor_4){
    setOut4_HIGH();
  }
  else{
    setOut4_LOW();
  }
  outputCounter_4++;
  if(outputCounter_4 >= outputPeriod_4){
    outputCounter_4 = 0;
  }
  /*
  // OUT 5
   if(outputCounter_5 < outputOnFor_5){
   setOut5_HIGH();
   }
   else{
   setOut5_LOW();
   }
   outputCounter_5++;
   if(outputCounter_5 >= outputPeriod_5){
   outputCounter_5 = 0;
   }
   // OUT 6
   if(outputCounter_6 < outputOnFor_6){
   setOut6_HIGH();
   }
   else{
   setOut6_LOW();
   }
   outputCounter_6++;
   if(outputCounter_6 >= outputPeriod_6){
   outputCounter_6 = 0;
   }
   // OUT 7
   if(outputCounter_7 < outputOnFor_7){
   setOut7_HIGH();
   }
   else{
   setOut7_LOW();
   }
   outputCounter_7++;
   if(outputCounter_7 >= outputPeriod_7){
   outputCounter_7 = 0;
   }
   */

  /*
  switch(inputLEDAlternator++){
   case 0: 
   {
   // InLED 0
   if(inputVals[0] > inputLEDCounter*24){
   setInLED0_HIGH();
   }
   else{
   setInLED0_LOW();
   }
   break;
   }
   case 1: 
   {
   // InLED 1
   if(inputVals[1] > inputLEDCounter*24){
   setInLED1_HIGH();
   }
   else{
   setInLED1_LOW();
   }
   break;
   }
   case 2: 
   {
   // InLED 2
   if(inputVals[2] > inputLEDCounter*24){
   setInLED2_HIGH();
   }
   else{
   setInLED2_LOW();
   }
   break;
   }
   case 3: 
   {
   // InLED 3
   if(inputVals[3] > inputLEDCounter*24){
   setInLED3_HIGH();
   }
   else{
   setInLED3_LOW();
   }
   break;
   }
   case 4: 
   {
   // InLED 4
   if(inputVals[4] > inputLEDCounter*24){
   setInLED4_HIGH();
   }
   else{
   setInLED4_LOW();
   }
   break;
   }
   case 5: 
   {
   // InLED 5
   if(inputVals[5] > inputLEDCounter*24){
   setInLED5_HIGH();
   }
   else{
   setInLED5_LOW();
   }
   break;
   }
   case 6: 
   {
   // InLED 6
   if(inputVals[6] > inputLEDCounter*24){
   setInLED6_HIGH();
   }
   else{
   setInLED6_LOW();
   }
   break;
   }
   case 7: 
   {
   // InLED 7
   if(inputVals[7] > inputLEDCounter*24){
   setInLED7_HIGH();
   }
   else{
   setInLED7_LOW();
   }
   break;
   }
   default: 
   {
   inputLEDAlternator = 0;
   inputLEDCounter++;
   if(inputLEDCounter > 48){
   inputLEDCounter = 1;
   }
   }
   }
   */

  setDebugLightOff();
}


